       program LIVEFAST
       implicit real*8(a-h,r-z)
       implicit integer(i-n)
       implicit character*2(o) 
       implicit character*60(q)
       external ricer1,ricer2,ricer3,ricer4,ricer5,para
       external ricer6,ricer7,ricer8,ricer9,ric10,ric11
       parameter (maxiso=2500,maxlev=525) 
       dimension en(maxiso,maxlev),sp(maxiso,maxlev),isom(maxiso),
     .           isoz(maxiso),ip(maxiso,maxlev),beta2(100,350)
       common/matrici/en,sp,isom,isoz,ip,beta2
       open (unit=10,file='levels_mod.dat')
       write (*,*) ''
       write (*,*) ''             
       write (*,950)
     . '************************************************************',
     . '*                                                          *',
     . '*                        Live  Fast  	                   *',
     . '*                         ver. 1                           *',
     . '*                   by Lorenzo Fortunato                   *',
     . '*                    Oct.`02 -- Mar.`03                    *',
     . '*                                                          *',
     . '************************************************************',
     . '*                                                          *',
     . '*  This code reads the budapest descrete levels with well- *',
     . '*  assigned spin-parity (levels_mod.dat). This is a fast   *',
     . '*  trial version with limited capabilites.                 *',
     . '*                                                          *',
     . '************************************************************'

c  Il numero di isotopi letti e' 2500
c  Il numero max dei livelli di cui si e' sicuri e' 523

c----- Lettura dati e scrittura matrici------------------------
       do i=1,2500                              ! PORTARE A 2500
       no=0
       do k=1,maxlev 
       read(10,998) oflag,ipar,spin,oo,ener,mass,icha,levn
       if (oflag.eq.'#') then
                   en(i,k)=-100
                   sp(i,k)=-100
                   goto 100
       endif
       isom(i)=mass
       isoz(i)=icha 
c       write(*,998) oflag,ipar,spin,ener,mass,icha,levn
       en(i,k)=ener
       sp(i,k)=spin
       ip(i,k)=ipar
       enddo
 100   k=k
c       write(*,998) '#',0,0.0,0.0,0,0,0
       enddo




       write(*,*) 'Choose nucleus (0) or search (1):'
       read(*,*) nnuu
       write(*,*) '-------------------------------------------'
       if(nnuu.eq.0) then 
                  call isotope0
       elseif (nnuu.eq.1) then 
                  call ricer1
       endif


       write(*,*)''
       write(*,*)'WARNING: there are more states than the one displayed'
       write(*,*)'=======  by this code. Only well assigned spin-parity'
       write(*,*)'         states have been selected. Check your work!!'
       write(*,*)''
       
 950   format (15(a60,/))
 998   format (A1,I3,F4.1,A1,F8.5,3I3)
            
 1000  end
c==================================================================
c==================================================================

       subroutine isotope0
c-------------------------------------------------------------
c 
c-------------------------------------------------------------
      implicit real*8(a-h,r-z)
      implicit integer(i-n)
      implicit character*2(o)  
      implicit character*60(o) 
      parameter (maxiso=2500,maxlev=525) 
      dimension en(maxiso,maxlev),sp(maxiso,maxlev),isom(maxiso),
     .           isoz(maxiso),ip(maxiso,maxlev),beta2(100,350)
      common/matrici/en,sp,isom,isoz,ip,beta2
      print *,'Subroutine: isotope'
      print *,'---------------------'
 10   write (*,*) 'A, Z :'
      read (*,*) imaa,izaa
       
      do i=0,2500
      if(isom(i).eq.imaa.and.isoz(i).eq.izaa) then
          ii=i
          write(*,*)'==================================='
          write(*,*) isom(ii),isoz(ii)
          write(*,*)'-----------------------------------'
          write(*,*)' p   spn   energy       n'
          do k=1,maxlev 
            if (ip(ii,k).eq.0)  goto 80
            write(*,880) ip(ii,k),sp(ii,k), en(ii,k), k
            mxx=k
          enddo
      endif
 80   enddo
 81   write (*,*) '(o)ther isotope, (n)ormalize energies or (e)xit :'
      read (*,*) oyeah
      if(oyeah.eq.'o') then
                       goto 10
      elseif(oyeah.eq.'e') then
                       goto 881
      elseif(oyeah.eq.'n') then
                       goto 300
      else
              write(*,*) 'What ?'
              goto 81
      endif
 300  write(*,*) 'Choose the level (n>1) to be set at 1.0 energy?'
      read(*,*) norlev
      print *,en(ii,norlev)
      do k=1,mxx
          ennor=en(ii,k)/en(ii,norlev)
          write(*,880) ip(ii,k),sp(ii,k),ennor, k

      enddo
      goto 81

 880  format(I3,2X,F4.1,2X,F8.5,2X,1X,1X,I3)
 881  end


  
c################################################################
    
       subroutine ricer1
       implicit real*8(a-h,r-z)
       implicit integer(i-n)
       implicit character*2(o)
       implicit character*60(q)
       parameter (maxiso=2500,maxlev=525) 
       dimension en(maxiso,maxlev),sp(maxiso,maxlev),isom(maxiso),
     .           isoz(maxiso),ip(maxiso,maxlev),beta2(100,350)
       common/matrici/en,sp,isom,isoz,ip,beta2
       open(unit=20,name='die.out',status='unknown')

       print *,'Subroutine: ricerca 1'
       print *,'---------------------'
       write(*,*)'Choose spin and parity (+/- 1) of the first level'
       read(*,*) spz1, np1
       write(*,*)'Choose the maximum number of level to consider'
       read(*,*) maxk
       write(*,*)'The energy of this state is set to 1.00000'
       print *,'---------------------'
       write(*,*)''
       write(*,*)'Choose spin and parity (+/- 1) of the second level'
       read(*,*) spz2, np2
       write(*,*)'Choose the energy range to be considered'
       read(*,*) a,b
       write(*,*)'Choose the maximum number of level to be considered'
       write(*,*)'     put a big integer if you`re in troubles :)'
       read(*,*) maxj
       

       write(20,*) np1,' ',spz1, ' set at 1.0000' 
       write(20,*) np2,' ',spz2, ' from',a,' to',b
       write(20,*) '...............................'


c++++++DO-loop sugli isotopi-----------------------------------------
       do i=1,2500
c-------Seleziona i pari-pari---------
        if(isom(i).eq.0) goto200
        if(mod(isom(i),2).ne.0.or.mod(isoz(i),2).ne.0) goto 200

c-------Seleziono i ground state uguali a + zero-----
        if(sp(i,1).ne.0.0) goto 200
        if(ip(i,1).ne.1) goto 200
       
c+++++++DO-loop sui livelli------------------------------------
        do k=2,maxk
        if (en(i,k).le.-50.) goto 200 ! se finiscono -> cambia isotopo
        if (sp(i,k).eq.spz1.and.ip(i,k).eq.np1) then
           unit=en(i,k)               ! lo usi come unita' di energia
           do j=k+1,maxj
            if (en(i,j).le.-50.) goto 100 ! se finiscono->cambia 1o 
            if (sp(i,j).eq.spz2.and.ip(i,j).eq.np2) then
              xx=en(i,j)/unit 
              if(xx.ge.a.and.xx.le.b) then
                 write(20,*)'==================================='
                 write (20,*) isom(i),isoz(i),' ----->',i
                 write (20,*)'-----------------'
c                 if (k.gt.1) then
                  do m=1,k-1
                  write (20,880) ip(i,m),sp(i,m),en(i,m)/unit,en(i,m),
     .                           ' ->',m 
                  enddo
c                 endif
                 write (20,881) ip(i,k),sp(i,k),en(i,k)/unit,en(i,k),
     .                          ' ->',k,' <==1'
                  do n=k+1,j-1
                  write (20,880) ip(i,n),sp(i,n),en(i,n)/unit,en(i,n),
     .                           ' ->',n 
                  enddo
                 write (20,881) ip(i,j),sp(i,j),en(i,j)/unit,en(i,j),
     .                          ' ->',j,' <==2'
                 do l=j+1,maxlev
                   if (en(i,l).le.-50.) goto 80 ! se finiscono->cambia 2o
                   write(20,880) ip(i,l),sp(i,l),en(i,l)/unit,en(i,l),
     .                         ' ->',l 
                 enddo
              else
                 goto 80
              endif
            endif
 80        enddo

        endif
 100    enddo


 200  enddo
      write(*,*)''
      write(*,*) 'OUTPUT in file: die.out'
      write(*,*) '------'

 880  format(I3,F4.1,F8.5,1X,F8.5,A3,I3)
 881  format(I3,F4.1,F8.5,1X,F8.5,A3,I3,A6)
       end
